﻿Imports System
Imports System.Collections.Generic
Imports System.Linq

Namespace ElasticSearchRepository

    Public Class DiscoveryRepository
        Inherits BaseRepository
        Public Sub New(Optional ByVal elastiSearchServerUrl As Uri = Nothing)
            MyBase.New(elastiSearchServerUrl)
        End Sub

        ''' <summary>
        ''' Searches all indexes and all fields.
        ''' </summary>
        ''' <param name="queryTerm">The query term.</param>
        ''' <returns>A search results.</returns>
        Public Function SearchAll(ByVal queryTerm As String) As List(Of Tuple(Of String, String))
            Dim queryResult = Me.client.Search(Of Object)(Function(d) d.AllIndices().AllTypes().QueryString(queryTerm))

            Return queryResult.Hits.Select(Function(c) New Tuple(Of String, String)(c.Index, c.Source.name.Value)).Distinct().ToList()
        End Function

        ''' <summary>
        ''' A fuzzye search.
        ''' </summary>
        ''' <param name="queryTerm">The query term.</param>
        ''' <returns>A search results.</returns>
        Public Function FuzzySearch(ByVal queryTerm As String) As Object
            Return Me.client.Search(Of Object)(Function(d) d.AllIndices().AllTypes().Query(Function(q) q.Fuzzy(Function(f) f.Value(queryTerm))))
        End Function
    End Class
End Namespace
