﻿Imports Nest
Imports EnterpriseSearch

Namespace ElasticSearchRepository

	Public Class IndexRepository
		Inherits BaseRepository
		Public Sub New(Optional ByVal elastiSearchServerUrl As Uri = Nothing)
			MyBase.New(elastiSearchServerUrl)
		End Sub

		''' <summary>
		''' Creates a mapping for marketing documents.
		''' </summary>
		Public Sub CreateMarketingIndex()
			Me.client.CreateIndex("marketing", Function(c) c.AddMapping(Of MarketingDocument) (Function(m) m.Properties(Function(ps) ps.Attachment (Function(a) a.Name(Function(o) o.Document).TitleField(Function(t) t.Name(Function(x) x.Name).TermVector(TermVectorOption.WithPositionsOffsets))))))
		End Sub

		''' <summary>
		''' Indexes the data.
		''' </summary>
		''' <param name="clientdata">The data to index.</param>
		''' <param name="indexName">Name of the index.</param>
		''' <param name="mappingType">Type name of the mapping.</param>
		''' <returns>True is index succeded</returns>
		Public Function IndexData(Of T As {Class, New})(ByVal data As T, Optional ByVal indexName As String = Nothing, Optional ByVal mappingType As String = Nothing) As Boolean

			If client Is Nothing Then
				Throw New ArgumentNullException("data")
			End If

			Dim result = Me.client.Index(Of T)(data, Function(c) c.Index(indexName).Type(mappingType))
			Return result.IsValid
		End Function
	End Class
End Namespace
